<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-01-04
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * admin/index.php
 *
 * El directorio admin puede renombrarse por seguridad,
 * también debe renombrarse entonces en el inc/config-SWPHP.inc.php
 * y en el .htaccess del raiz.
 *
 */

chdir('../');

if(!is_file('config/config-SWPHP.inc.php') && is_file('config/config.inc.php'))
{
	rename('config/config.inc.php', 'config/config-SWPHP.inc.php');
}

require('config/config-SWPHP.inc.php');
require(SWPHP_INC_DIR.'comunini.inc.php');

if(!$_SERVER['HTTPS'] && SWPHP::_GetConfigValue('forzarssl', 'configuracion_admin', false))
{
	header('HTTP/1.1 301 Moved Permanently');
	header('Location: https://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']);
	exit;
}

$swphp_portada = false;
$swphp_administracion = true;

$paginaActual = SWPHP_ADMIN_DIR;
$admin_template = 'admin/default.tpl';

SWPHP::$breadcrumb->Add($paginaActual, l('Administración'), l('Panel de administración'));

if(isset($_SESSION['user']['autenticado']) && $_SESSION['user']['autenticado'])
{
	if(is_dir('install'))
	{
		SWPHP::_Msg(l('Por seguridad, tienes que eliminar la carpeta').' <b>install</b>', 'aviso');
	}

	$cargarModulo = false;

	if(isset($_GET['mod']) && $_GET['mod'] != '')
	{
		$swphp_mod_clave = string2friendly($_GET['mod']);
		$row = $db->GetRow("SELECT id, titulo, descripcion, icono, version FROM ".SWPHP_DBPREFIX."modulos WHERE clave = '{$swphp_mod_clave}' AND activo = 1", true, false);
		if($row)
		{
			$swphp_permiso_id = SWPHP::_GetPermiso($row['id'], $_SESSION['user']['perfil_id']);

			if($swphp_permiso_id > SWPHP_PERMISO_SOLOLECTURA)
			{
				$swphp_pagina->SetValues(
					$row['titulo'],
					'',
					$row['descripcion'],
					'',
					'',
					$row['icono']
					);

				$cargarModulo = true;
			}
			else
			{
				SWPHP::_Msg('No autorizado', 'prohibido');
			}
		}
	}

	if($cargarModulo)
	{
		//CARGAR MODULO

		$paginaActual .= "{$swphp_mod_clave}/";

		SWPHP::$breadcrumb->Add($paginaActual, $swphp_pagina->GetValue('titulo'), $swphp_pagina->GetValue('descripcion'));

		$diradmin = SWPHP_MODULES_DIR."{$swphp_mod_clave}/admin/";
		$dir = $diradmin;
        $swphp_sub = '';
		$sub = 'sub';
		for($c=0; $c<2; $c++)
		{
			$aux = isset($_GET[$sub]) && $_GET[$sub] ? $_GET[$sub] : false;

			if($aux)
			{
				$swphp_sub = $aux;
				$paginaActual .= "{$swphp_sub}/";
				$dir .= "{$swphp_sub}/";

				//Cargo el array de información $submodulo definido en info.php
				//if(SWPHP::_Include('info.php', $dir) && isset($submodulo['titulo']))
				if(is_file($dir.'info.php'))
				{
					include($dir.'info.php');

					SWPHP::$breadcrumb->Add($paginaActual, $submodulo['titulo'], $submodulo['descripcion']);

					if(isset($submodulo['permiso_id']) && $swphp_permiso_id < $submodulo['permiso_id'])
					{
						SWPHP::_Msg('No autorizado', 'prohibido');
						$cargarModulo = false;
						break;
					}
					else
					{
						$smarty->assign('swphp_submodulo', $submodulo);
					}
				}
				else
				{
					SWPHP::$breadcrumb->Add($paginaActual, $swphp_sub, $swphp_sub);
				}
			}
            else
            {
                break;
            }

			$sub = 's'.$sub;
		}

		if($cargarModulo)
		{
			$file = "{$dir}index.php";
			if(is_file($file))
			{
				$swphp_module_dir = SWPHP_MODULES_DIR."{$swphp_mod_clave}/";
				$swphp_module_templates_dir = "../../../".SWPHP_MODULES_DIR."{$swphp_mod_clave}/tpl/";
				SWPHP::_LoadModuleLang($swphp_mod_clave);
				SWPHP::_Include('functions.inc.php', $swphp_module_dir);
				SWPHP::_Include('functions.inc.php', $dir);
				if($diradmin != $dir)
				{
					SWPHP::_Include('functions.inc.php', $diradmin);
				}

				if(SWPHP::_Include('xajax.inc.php', $dir))
				{
					require(SWPHP_COMMON_DIR.'classes/SWPHP_Xajax.class.php');

					$xajax->processRequest();
				}

				SWPHP::_CheckVersionModulo($swphp_mod_clave, $row['version']);

				include($file);
			}
			else
			{
				SWPHP::_Msg("No se encuentra el archivo de módulo: {$file}", "error");
			}

			$smarty->assign('swphp_mod_clave', $swphp_mod_clave);
			$smarty->assign('swphp_sub', $swphp_sub);
		}
	}

	if(!$cargarModulo)
	{
		//MENU PRINCIPAL DEL PANEL DE CONTROL

		$swphp_pagina->SetValues(
			'',
			'',
			'Panel de administración',
			'panel, administracion, backend'
			);
		$smarty->assign('swphp_modulos', SWPHP::_GetModulosAdmin($_SESSION['user']['perfil_id'], 2));
	}
}
else
{
	SWPHP::_PedirLogin($admin_template);
}

define('SWPHP_PAGINA_ACTUAL', $paginaActual);
unset($paginaActual);

$smarty->assign('swphp_templatecontenido', $admin_template);
$smarty->assign('swphp_localizador', SWPHP::$breadcrumb->GetItems());

$swphp_pagina->SetValue('robots', 'none');

require_once(SWPHP_INC_DIR.'comunfin.inc.php');
