<?php
/**
 * captcha
 * @author José Carlos Cruz Parra AKA internia
 * josecarlos@programadorphpfreelance.com
 * http://programadorphpfreelance.com
 * 2009-2016
 * This code is released under the GNU General Public License.
 */

//****************************************************
//CONFIG

$comotexto_operandos = mt_rand(0, 1); //Mostrar operandos como texto o como número
$comotexto_operador = mt_rand(0, 1); //Mostrar operación como texto o como símbolo
$truetype = false; //Usar o no true type
$truetype_size = 20; //Tamaño para la fuente true type

$bgcolor = array(
	'R'=>255,
	'G'=>255,
	'B'=>255,
	);
$fgcolor = array(
	'R'=>array(0, 220),
	'G'=>array(0, 220),
	'B'=>array(0, 220),
	);

//****************************************************
//Si utilizas una configuración personalizada para manejo de sesiones,
//como por ejemplo funciones personalizadas,
//especifícalo aquí

include('config/config-SWPHP.inc.php');
require(SWPHP_COMMON_DIR.'classes/MyCache.class.php');
require(SWPHP_COMMON_DIR.'classes/DB_ResultSet.class.php');
require(SWPHP_COMMON_DIR.'classes/DB_Connection.class.php');
include(SWPHP_INC_DIR.'session.inc.php');

//Vamos a utilizar una fuente true type aleatoriamente seleccionada

include_once(SWPHP_COMMON_DIR.'functions/files.php');

$dirfonts = "files/fonts/";
$fonts = getFilesExt($dirfonts, array('ttf'), true);
$hayfonts = sizeof($fonts) > 0;
$fontfile = $hayfonts ? $fonts[array_rand($fonts)] : null; //Archivo de fuente (necesario para true type)

//****************************************************
//No tocar a partir de aquí

if(isset($_GET['comotexto'])) //Compatibilidad hacia atrás
{
	$comotexto_operandos = $_GET['comotexto'] ? true : false;
	$comotexto_operador = $_GET['comotexto'] ? true : false;
}
if(isset($_GET['comotexto_operandos']))
{
	$comotexto_operandos = $_GET['comotexto_operandos'] ? true : false;
}
if(isset($_GET['comotexto_operador']))
{
	$comotexto_operador = $_GET['comotexto_operador'] ? true : false;
}
if(isset($_GET['truetype']))
{
	$truetype = $_GET['truetype'] && $hayfonts;
}
if(isset($_GET['fontfile']) && in_array($_GET['fontfile'], $fonts))
{
	$fontfile = str_replace('..', '', $_GET['fontfile']);
}
if(isset($_GET['bgcolorR']))
{
	$bgcolor['R'] = intval($_GET['bgcolorR']);
}
if(isset($_GET['bgcolorG']))
{
	$bgcolor['G'] = intval($_GET['bgcolorG']);
}
if(isset($_GET['bgcolorB']))
{
	$bgcolor['B'] = intval($_GET['bgcolorB']);
}
if(isset($_GET['fgcolorR']))
{
	$fgcolor['R'] = intval($_GET['fgcolorR']);
}
if(isset($_GET['fgcolorG']))
{
	$fgcolor['G'] = intval($_GET['fgcolorG']);
}
if(isset($_GET['fgcolorB']))
{
	$fgcolor['B'] = intval($_GET['fgcolorB']);
}

$operandos = array(
	'1'=>'uno',
	'2'=>'dos',
	'3'=>'tres',
	'4'=>'cuatro',
	'5'=>'cinco',
	'6'=>'seis',
	'7'=>'siete',
	'8'=>'ocho',
	'9'=>'nueve',
	);
$operadores = array(
	'+'=>'mas',
	'-'=>'menos',
	'*'=>'por',
	);
$operadores_keys = array_keys($operadores);

$resultado = 0;
//No queremos resultados cero
while($resultado == 0)
{
	$operador = $operadores_keys[mt_rand(0, sizeof($operadores)-1)];
	$n = mt_rand(1, 9);
	$m = mt_rand(1, 9);
	if($operador == '-' && $m > $n)
	{
		$aux = $n;
		$n = $m;
		$m = $aux;
	}

	$operacion = sprintf('%d %s %d',
		$n,
		$operador,
		$m
		);

	$resultado = eval("return {$operacion};");
}

$_SESSION['chacha'] = $resultado;

$str = sprintf('%s %s %s',
	$comotexto_operandos ? $operandos[$n] : $n,
	$comotexto_operador ? $operadores[$operador] : str_replace('*', 'x', $operador),
	$comotexto_operandos ? $operandos[$m] : $m
	);
$h = $truetype ? 28 : 20;
$w = mb_strlen($str) * ($truetype ? ($truetype_size / 1.4) : 10);

$im = imagecreate($w, $h);

imagecolorallocate($im, $bgcolor['R'], $bgcolor['G'], $bgcolor['B']);

header('Content-Type: image/png');

for($c=0; $c<10; $c++)
{
	imageline($im, mt_rand(0, $w), mt_rand(0, $h), mt_rand(0, $w), mt_rand(0, $h), imagecolorallocate($im, mt_rand(180, 240), mt_rand(180, 240), mt_rand(180, 240)));
}

if($truetype)
{
	$color = captcha_arr2color($fgcolor);
	imagettftext($im, $truetype_size, 0, 10, 22, imagecolorallocate($im, $color['R'], $color['G'], $color['B']), $fontfile, $char);
}
else
{
	for($c=0,$len=mb_strlen($str),$espacios=''; $c<$len; $c++,$espacios.=' ')
	{
		$char = mb_substr($str, $c, 1);
		$color = captcha_arr2color($fgcolor);
		imagestring($im, 5, 0, 0, $espacios.$char, imagecolorallocate($im, $color['R'], $color['G'], $color['B']));
	}
}

imagepng($im);
exit;


/* FUNCIONES */

function captcha_arr2color($arr)
{
	$c = 0;
	do
	{
		$c++;
		$R = is_string($arr['R']) ? $arr['R'] : mt_rand($arr['R'][0], $arr['R'][1]);
		$G = is_string($arr['G']) ? $arr['G'] : mt_rand($arr['G'][0], $arr['G'][1]);
		$B = is_string($arr['B']) ? $arr['B'] : mt_rand($arr['B'][0], $arr['B'][1]);
	}
	while(($R + $G + $B) > 400 || $c < 1000);

	return array('R'=>$R, 'G'=>$G, 'B'=>$B);
}