<?php
/**
 * @author José Carlos
 *
 * Para gestionar el baneo de IPs
 *
 */
class SWPHP_BanIP
{
	const HABILITADO = true;
	const MAX_DEFAULT = 5;

	private $_ip;

	public function __construct($ip=null)
	{
		global $db;

		//Limpiar antiguas
		$db->Execute("DELETE FROM ".SWPHP_DBPREFIX."banip WHERE (permanente = '0' AND fechayhora < '%s') OR (baneada = '0' AND fechayhora < '%s')", date('Y-m-d H:i:s', time() - 2592000), date('Y-m-d H:i:s', time() - 3600)); //2592000 segundos = 30 días

		if(is_null($ip))
		{
			$ip = GetClientIP();
		}

		$this->IP($ip);
	}
	/**
	 * Obtiene/Establece la IP.
	 *
	 * @param string $ip
	 * @return string
	 */
	public function IP($ip=null)
	{
		if(!is_null($ip))
		{
			$this->_ip = $ip;
		}

		return $this->_ip;
	}
	/**
	 * Registra un fallo.
	 *
	 * @global DB_Connection $db
	 * @param string $info
	 */
	public function Fallo($info)
	{
		if(self::HABILITADO)
		{
			global $db;

			$ahora = date('Y-m-d H:i:s');

			if($db->Exists($this->_ip, 'ip', SWPHP_DBPREFIX.'banip'))
			{
				$data = $db->GetRow(sprintf("SELECT fallos + 1 AS fallos, '%s' AS fechayhora, CONCAT(infofallos, '%s') AS infofallos FROM ".SWPHP_DBPREFIX."banip WHERE `ip` = '%s'", $ahora, "\n[".$ahora."] - ".addcslashes($info, "'"), addcslashes($this->_ip, "'")), true, false);
				$query = buildQuery_Update($data, SWPHP_DBPREFIX.'banip', array('ip'=>$this->_ip));
			}
			else
			{
				$data = array(
					'ip'		=>$this->_ip,
					'fallos'	=>1,
					'baneada'	=>0,
					'fechayhora'=>$ahora,
					'permanente'=>0,
					'infofallos'=>sprintf('[%s] - %s', $ahora, $info),
					);
				$query = buildQuery_Insert($data, SWPHP_DBPREFIX.'banip');
			}

			$db->Execute($query);
		}
	}
	/**
	 * Comprueba si una IP está baneada o ha alcanzado el máximo de fallos, en cuyo caso la banea.
	 * Devuelve true si es buena, y false si es baneada.
	 *
	 * @global DB_Connection $db
	 * @param int $max
	 * @return boolean
	 */
	public function Check($max=self::MAX_DEFAULT)
	{
		if(self::HABILITADO)
		{
			global $db;

			if($db->Exists($this->_ip, 'ip', SWPHP_DBPREFIX.'banip', "WHERE (`baneada` = '1' OR `fallos` >= ".(int)$max.")"))
			{
				$data = $db->GetRow("SELECT 1 AS baneada, IF(baneada, fechayhora, '".date('Y-m-d H:i:s')."') AS fechayhora FROM ".SWPHP_DBPREFIX."banip WHERE `ip` = '".addcslashes($this->_ip, "'")."'");
				$query = buildQuery_Update($data, SWPHP_DBPREFIX.'banip', array('ip'=>$this->_ip));

				$db->Execute($query);

				return false;
			}
		}

		return true;
	}
}