<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2009-10-23
 * 2012-04-13
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/comunini.inc.php
 */

//ACCIONES COMUNES AL INICIO DE CADA SCRIPT

//¡¡NO EDITAR!!
//Si quieres añadir acciones al inicio de cada script, hazlo en config/customini.inc.php

//Para que no se pierda la sesión cuando la página se muestra dentro de un frame
header('P3P: CP="CAO PSA OUR"');

if(!defined('SWPHP_DEBUG'))
{
	define('SWPHP_DEBUG', false);
}

//TODO: Zona horaria configurable
@date_default_timezone_set(date_default_timezone_get());

define('SWPHP_LOG_DIR', 'files/log/');

ini_set('variables_order', 'ES'); //Personalizar variables_order por razones de seguridad
ini_set('display_errors', SWPHP_DEBUG); //Desactivar mostrar errores y avisos (pueden ser útiles para un hacker). Activar en depuración
ini_set('display_startup_errors', SWPHP_DEBUG); //Se recomienda mantener display_startup_errors desactivado. Activar en depuración
ini_set('log_errors', true); //Guardar los mensajes de error y de aviso en un archivo de registro
ini_set('error_log', SWPHP_LOG_DIR.'php_errors.log'); //Ruta del archivo de registro de errores
ini_set('error_reporting', E_ALL); //Nivel de reporte de errores (recomendado "E_ALL")
ini_set('session.use_only_cookies', true);//Pasar la session_id sólo por cookie, no por url
ini_set('session.use_trans_sid', false);//Desactivar trans_sid para no arriesgar la seguridad de los usuarios

define('SWPHP_QUOTESTYLE', ENT_COMPAT);
define('SWPHP_CHARSET', 'UTF-8');

mb_internal_encoding(SWPHP_CHARSET);
mb_http_output(SWPHP_CHARSET);

//Deshacer magic quotes
if(get_magic_quotes_gpc())
{
    $process = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
    while(list($key, $val) = each($process))
    {
        foreach($val as $k=>$v)
        {
            unset($process[$key][$k]);
            if(is_array($v))
            {
                $process[$key][stripslashes($k)] = $v;
                $process[] = &$process[$key][stripslashes($k)];
            }
            else
            {
                $process[$key][stripslashes($k)] = stripslashes($v);
            }
        }
    }
    unset($process);
}

define('SWPHP_PERMISO_ACCESOPROHIBIDO', 0);
define('SWPHP_PERMISO_SOLOLECTURA', 1);
define('SWPHP_PERMISO_LECTURAYESCRITURA', 2);
define('SWPHP_PERMISO_ACCESOTOTAL', 3);

$_SERVER['HTTPS'] = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']) || $_SERVER['SERVER_PORT'] == '443';

require SWPHP_COMMON_DIR.'functions/internet.php';
require SWPHP_COMMON_DIR.'functions/sql.php';
require SWPHP_COMMON_DIR.'functions/files.php';
require SWPHP_COMMON_DIR.'classes/MyCache.class.php';
require SWPHP_COMMON_DIR.'classes/DB_ResultSet.class.php';
require SWPHP_COMMON_DIR.'classes/DB_Connection.class.php';
require SWPHP_COMMON_DIR.'classes/Pluralizador.class.php';
require SWPHP_COMMON_DIR.'classes/SWPHP.class.php';
require SWPHP_COMMON_DIR.'classes/SWPHP_Pagina.class.php';
require SWPHP_COMMON_DIR.'classes/SWPHP_Breadcrumb.class.php';

$db = DB_Connection::Factory(SWPHP_DBHOST, SWPHP_DBPORT, SWPHP_DBNAME, SWPHP_DBUSER, SWPHP_DBPASS, false, SWPHP_CHARSET, SWPHP_DEBUG, defined('SWPHP_DBCLASS') ? SWPHP_DBCLASS : null);
$db->SetQuoteStyle(SWPHP_QUOTESTYLE);
if($db->Connect(false) == false)
{
	die('No se puede conectar con el servidor de base de datos<br />'.$db->Error());
}
if($db->SelectDB() == false)
{
	die('No se puede seleccionar la base de datos<br />'.$db->Error());
}

$swphp_config = SWPHP::_GetConfigAssoc('configuracion');
if(isset($swphp_config['path']))
{
	$swphp_config['path'] = ponerBarra($swphp_config['path']);
	if(substr($swphp_config['path'], 0, 1) != '/')
	{
		$swphp_config['path'] = '/'.$swphp_config['path'];
	}
	$swphp_config['url'] = ($_SERVER['HTTPS'] ? 'https://' : 'http://').(isset($_SERVER['HTTP_HOST']) && $_SERVER['HTTP_HOST'] ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME']).$swphp_config['path'];
}
$swphp_config['path'] = url2path($swphp_config['url']);
$swphp_pagina = new SWPHP_Pagina();
SWPHP::$breadcrumb = new SWPHP_Breadcrumb();
$swphp_module_dir = "";
$swphp_module_templates_dir = "";
$swphp_portada = false;
$swphp_administracion = false;
$swphp_extrahead = '';
$swphp_documentready = '';

include(SWPHP_INC_DIR.'session.inc.php');

//MENSAJES
$swphp_mensajes = isset($_SESSION['swphp']['mensajes']) ? $_SESSION['swphp']['mensajes'] : array();
unset($_SESSION['swphp']['mensajes']);

//COMPROBACIÓN DE DEFINICIONES EN CONFIG
if(defined('SWPHP_THEME'))
{
	if(isset($swphp_config['theme']) && $swphp_config['theme'])
	{
		SWPHP::_Msg('Hay que eliminar la declaración de la constante SWPHP_THEME en config/config-SWPHP.inc.php', 'aviso');
	}
}
else
{
	define('SWPHP_THEME', $swphp_config['theme']);
}

if(!defined('SWPHP_TEMP_DIR'))
{
	SWPHP::_Msg('Hay que añadir la declaración de la constante SWPHP_TEMP_DIR a config/config-SWPHP.inc.php', 'aviso');
	define('SWPHP_TEMP_DIR', 'temp/');
}

//DEFINIR ALGUNAS CONSTANTES
define('SWPHP_SESSION_ID', session_id());
define('SWPHP_CLIENT_IP', GetClientIP());
define('SWPHP_MODULES_DIR', SWPHP_INC_DIR.'modulos/');
define('SWPHP_PLUGINS_DIR', SWPHP_INC_DIR.'plugins/');
define('SWPHP_THEME_DIR', SWPHP_THEMES_DIR.SWPHP_THEME.'/');

//IDIOMA
define('SWPHP_IDIOMA_POR_DEFECTO', SWPHP::_GetConfigValue('idioma', 'idiomas')); //Tiene que estar antes de GetIdiomas()
$swphp_lang = array(); //Array de traducciones (se llena con las traducciones del theme y de los módulos)
$swphp_idiomas = SWPHP::_GetIdiomas(); //Todos los idiomas activos
define('SWPHP_IDIOMA_POR_DEFECTO_CODIGOISO', $swphp_idiomas[SWPHP_IDIOMA_POR_DEFECTO]['codigoiso']);
SWPHP::_SetIdiomaActual();
SWPHP::_Include(SWPHP_THEME_DIR."lang/{$_SESSION['SWPHP_IDIOMA_ACTUAL_CODIGOISO']}/index.php");

$dir = 'js/swphp/lang/'.SWPHP_IDIOMA_POR_DEFECTO_CODIGOISO.'/';
$file = 'Validador.lang.js';
if(is_file($dir.$file))
{
	$swphp_extrahead .= '<script type="text/javascript" src="'.$dir.$file.'"></script>';
}

/*if(sizeof($swphp_idiomas) > 1)
{
	$swphp_config['url'] .= $_SESSION['SWPHP_IDIOMA_ACTUAL_CODIGOISO'].'/';
}*/

/* FUNCIONES */

/**
 * Traduce
 *
 * @param string $str
 * @param string $concepto
 * @param string $isocode
 * @return string
 */
function l($str, $concepto='theme', $isocode=null)
{
	global $swphp_lang, $swphp_mod_clave;

	$str = trim($str);
	$hash = md5($concepto.$str);

	$return = $str;

	if(!is_null($isocode) && $isocode != $_SESSION['SWPHP_IDIOMA_ACTUAL_CODIGOISO'])
	{
		if(!isset($swphp_lang[$isocode][$hash]))
		{
			$aux1 = $swphp_lang;

			if($concepto == 'theme')
			{
				SWPHP::_Include(SWPHP_THEME_DIR."lang/{$isocode}/index.php");
			}
			else
			{
				SWPHP::_LoadModuleLang($concepto, $isocode);
			}

			$aux2 = $swphp_lang;
			$swphp_lang = $aux1;
			$swphp_lang[$isocode] = $aux2;

			if(!isset($swphp_lang[$isocode][$hash]))
			{
				//$str = SWPHP::_T($str, SWPHP_IDIOMA_POR_DEFECTO_CODIGOISO, $isocode);

				//TODO: guardar traducción

				$swphp_lang[$isocode][$hash] = $str;
			}
		}

		$return = $swphp_lang[$isocode][$hash];
	}
	elseif(isset($swphp_lang[$hash]))
	{
		$return = $swphp_lang[$hash];
	}
	elseif($concepto == 'theme')
	{
		$hash = md5($swphp_mod_clave.$str);

		if(!isset($swphp_lang[$hash]))
		{
			//$str = SWPHP::_T($str, SWPHP_IDIOMA_POR_DEFECTO_CODIGOISO, $_SESSION['SWPHP_IDIOMA_ACTUAL_CODIGOISO']);

			//TODO: guardar traducción

			$swphp_lang[$hash] = $str;
		}

		$return = $swphp_lang[$hash];
	}
	else
	{
		//$str = SWPHP::_T($str, SWPHP_IDIOMA_POR_DEFECTO_CODIGOISO, $_SESSION['SWPHP_IDIOMA_ACTUAL_CODIGOISO']);

		//TODO: guardar traducción

		$swphp_lang[$hash] = $str;

		$return = $swphp_lang[$hash];
	}

	return function_exists($func = $concepto.'_prelang') ? $func($return) : $return;
}
