<?php
/**
 * Armando Servillera Torres
 * www.pagina-web-barata.com
 * 2012-01-11
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/kapitaltruth/admin/preguntas/admin/index.php
 *
 */

$kptl_config = SWPHP::_GetConfigValues('kapitaltruth', false, 'kptl_config');

$id = isset($_GET["id"]) ? intval($_GET["id"]) : 0;
$op = isset($_GET['op']) ? $_GET['op'] : '';

if($kptl_config['habilitarkptl'] && in_array($op, array('edit', 'new', 'upd', 'reg')))
{
	$op = '';
	SWPHP::_Msg(l('No se pueden gestionar las preguntas estando KPTL habilitado', 'kapitaltruth'), 'prohibido');
}

$mostrarprincipal = true;

switch($op)
{
	case "edit":
		$registro = $db->GetRow("SELECT * FROM ".SWPHP_DBPREFIX."kptl_preguntas WHERE id = '{$id}'");
		$registro['idiomas'] = array();
		foreach($swphp_idiomas as $idioma)
		{
			$registro['idiomas'][$idioma['id']] = $db->GetRow("SELECT texto FROM ".SWPHP_DBPREFIX."kptl_preguntas_idiomas WHERE pregunta_id = '{$id}' AND idioma_id = '{$idioma['id']}'");
		}

		$smarty->assign("registro", $registro);
        //sigue
	case "new":
		$smarty->assign('setsrespuestas', kapitaltruth_preguntas_getSetsRespuestas());
		$smarty->assign('categorias', $db->GetArrayForHTMLSelectQuery("SELECT c.id, ci.texto FROM ".SWPHP_DBPREFIX."kptl_categorias AS c JOIN ".SWPHP_DBPREFIX."kptl_categorias_idiomas AS ci ON c.id = ci.categoria_id AND ci.idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."' ORDER BY c.peso ASC", array('', l('Seleccionar...', 'kapitaltruth'))));

		$admin_template = "{$swphp_module_templates_dir}admin/preguntas/pregunta.tpl";
		$mostrarprincipal = false;

		SWPHP::_AddDocumentReady("$('.editlang').children('.lang').click(function(event){EditLangs(event);});");
		break;
	case "upd":
		if(!KPTL_ActuacionesAdmin::Act('ModPregunta', array('id'=>$id), $_POST))
		{
			$mostrarprincipal = false;
		}
		break;
	case "reg":
		if(!KPTL_ActuacionesAdmin::Act('AddPregunta', array(), $_POST))
		{
			$mostrarprincipal = false;
		}
		break;
}

if($mostrarprincipal)
{
	$paginador = SWPHP::_CrearPaginador('preguntas');
	$paginador->SetParam('etiqueta', l("pregunta", 'kapitaltruth'));
	$paginador->Fill("SELECT p.id, ci.texto AS categoria, pi.texto, p.activo"
		." FROM ".SWPHP_DBPREFIX."kptl_preguntas AS p"
		." JOIN ".SWPHP_DBPREFIX."kptl_categorias AS c ON c.id = p.categoria_id"
		." JOIN ".SWPHP_DBPREFIX."kptl_categorias_idiomas AS ci ON ci.categoria_id = c.id AND ci.idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'"
		." JOIN ".SWPHP_DBPREFIX."kptl_preguntas_idiomas AS pi ON p.id = pi.pregunta_id AND pi.idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'"
		." ORDER BY c.peso, p.categoria_id, p.peso, p.id");

	$paginador->SetParam('campos', array(
		'id'=>array("label"=>l("Id.", 'kapitaltruth'), "class"=>"numeric", "style"=>"width:64px"),
		'categoria'=>array("label"=>l("Categoría", 'kapitaltruth'), "style"=>"width:160px"),
		'texto'=>array("label"=>l("Texto", 'kapitaltruth')),
		'activo'=>array("label"=>"", "orderby"=>false, "style"=>"width:60px")
		));

	$paginador->SetParam('buscador', array(
		'ci.texto'=>l('Categoría (nombre)', 'kapitaltruth'),
		'p.categoria_id'=>l('Categoría (id)', 'kapitaltruth'),
		'pi.texto'=>l('Texto', 'kapitaltruth'),
		'p.activo'=>l('Activa', 'kapitaltruth'),
		'p.id'=>l('Id.', 'kapitaltruth'),
		));

	function applyToReg(&$reg, $key)
	{
		global $swphp_mod_clave, $kptl_config;

		$id = $reg['id'];

		if($kptl_config['habilitarkptl'])
		{
			$reg["activo"] = '';
		}
		else
		{
			$reg["activo"] = ($reg["activo"] ?
				" <a id=\"aActivar{$id}\" href=\"javascript:;\" onclick=\"xajax_Activar({$id})\" title=\"Desactivar\">".SWPHP::_Icon("green_button.png", 16, array("alt"=>"Desactivar"))."</a>"
				:
				" <a id=\"aActivar{$id}\" href=\"javascript:;\" onclick=\"xajax_Activar({$id})\" title=\"Activar\">".SWPHP::_Icon("red_button.png", 16, array("alt"=>"Activar"))."</a>")
			." <a href=\"".SWPHP_ADMIN_DIR.$swphp_mod_clave."/preguntas/?op=edit&amp;id={$id}\">".SWPHP::_Icon("edit.png", 16, array("alt"=>"Editar", "title"=>"Editar Id. {$id}"))."</a>"
			." <a id=\"aEliminar{$id}\" href=\"javascript:EliminarPregunta({$id})\" title=\"Eliminar\">".SWPHP::_Icon("remove.png", 16, array("alt"=>"Eliminar", "title"=>"Eliminar Id. {$id}"))."</a>";
		}
	}
	$paginador->SetParam('applyToRegs', 'applyToReg');

	$admin_template = "{$swphp_module_templates_dir}admin/preguntas/preguntas.tpl";

	$smarty->assign('paginador', $paginador);

	$smarty->assign("kptl_config", $kptl_config);
}
