<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-04-07
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/kapitaltruth/admin/usuarios/index.php
 *
 */

$kptl_config = SWPHP::_GetConfigValues('kapitaltruth', false, 'kptl_config');

$id = isset($_GET["id"]) ? intval($_GET["id"]) : 0;
$op = isset($_GET['op']) ? $_GET['op'] : '';

$user_id = $id > 0 ? $db->GetValue("user_id", SWPHP_DBPREFIX."kptl_usuarios", "WHERE id = '{$id}'", true, false) : 0;

$mostrarprincipal = true;

switch($op)
{
	case "edit":
		$registro = $db->GetRow("SELECT ku.user_id, ku.id, u.nick, ku.nombre, u.email, ku.fechanacimiento, u.activo, ku.grupos, u.perfil_id FROM ".SWPHP_DBPREFIX."users AS u JOIN ".SWPHP_DBPREFIX."kptl_usuarios AS ku ON ku.user_id = u.id WHERE ku.id = '{$id}'");
		if(!empty($registro['grupos']))
        {
            $registro['grupos'] = unserialize(html_entity_decode($registro['grupos']));
        }
        if($registro['fechanacimiento'] == '0000-00-00')
		{
			$registro['fechanacimiento'] = '';
		}
		$smarty->assign('registro', $registro);
		//sigue
	case "new":
        $smarty->assign('grupos', KPTL::GetGruposForHTMLSelect());
		$smarty->assign('convertibles', kapitaltruth_usuarios_getConvertibles());
		$admin_template = "{$swphp_module_templates_dir}admin/usuarios/".(isset($registro['perfil_id']) && $registro['perfil_id'] >= $_SESSION['user']['perfil_id'] ? "usuario_readonly.tpl" : "usuario.tpl");
		$mostrarprincipal = false;
		break;
	case "upd":
		if(!KPTL_ActuacionesAdmin::Act('ModUsuario', array('id'=>$id, 'user_id'=>$user_id), $_POST))
		{
			$mostrarprincipal = false;
		}
		break;
	case "reg":
		if(!KPTL_ActuacionesAdmin::Act('AddUsuario', array(), $_POST))
		{
			$mostrarprincipal = false;
		}
		break;
}

if($mostrarprincipal)
{
	include_once(SWPHP_COMMON_DIR.'functions/date.php');

	$paginador = SWPHP::_CrearPaginador('usuarios');
	$paginador->SetParam('etiqueta', l("usuario", 'kapitaltruth'));
	$paginador->Fill("SELECT ku.user_id, ku.id, u.nick, ku.nombre, u.email, ku.fechanacimiento, ku.puntos_show, SUBSTRING(ku.fechayhoraalta,1,10) AS fechaalta, u.contadorlogin, u.ultimologin, u.activo"
		." FROM ".SWPHP_DBPREFIX."users AS u"
		." JOIN ".SWPHP_DBPREFIX."kptl_usuarios AS ku ON ku.user_id = u.id"
        .(empty($_GET['grupo_id']) ? '' : " WHERE ku.grupos LIKE '%\"".(int)$_GET['grupo_id']."\"%'")
		//." WHERE u.perfil_id <= '{$_SESSION['user']['perfil_id']}'"
		." ORDER BY u.nick ASC");

	$paginador->SetParam('campos', array(
		'user_id'=>array("hidden"=>true),
		'id'=>array("label"=>l("Id.", 'kapitaltruth'), "class"=>"numeric", "style"=>"width:64px"),
		'nick'=>array("label"=>l("Alias", 'kapitaltruth')),
		'nombre'=>array("label"=>l("Nombre real", 'kapitaltruth')),
		'email'=>array("label"=>l("Email", 'kapitaltruth')),
		'fechanacimiento'=>array("label"=>l("Edad", 'kapitaltruth'), "class"=>"numeric"),
		'puntos_show'=>array("label"=>l("[KPTL_Puntos]", 'kapitaltruth'), "class"=>"numeric"),
		'fechaalta'=>array("label"=>l("Fecha alta", 'kapitaltruth'), "class"=>"center"),
		'contadorlogin'=>array("label"=>l("Accesos", 'kapitaltruth'), "class"=>"numeric"),
		'ultimologin'=>array("label"=>l("Último acceso", 'kapitaltruth')),
		'activo'=>array("label"=>"", "orderby"=>false, "style"=>"width:60px")
		));

	$paginador->SetParam('buscador', array(
		'u.nick'=>l('Alias (nick)', 'kapitaltruth'),
		'ku.nombre'=>l('Nombre real', 'kapitaltruth'),
		'u.email'=>l('Email', 'kapitaltruth'),
		'ku.fechayhoraalta'=>l('Fecha alta', 'kapitaltruth'),
		'u.ultimologin'=>l('Último acceso', 'kapitaltruth'),
		'ku.id'=>l('Id.', 'kapitaltruth'),
        ));

    function applyToReg(&$reg, $key)
	{
		global $swphp_mod_clave;

		$id = $reg['id'];

		$reg["fechanacimiento"] = $reg["fechanacimiento"] != '0000-00-00' ? calcularEdad(substr($reg["fechanacimiento"], 8, 2), substr($reg["fechanacimiento"], 5, 2), substr($reg["fechanacimiento"], 0, 4)).' años' : '';

		$reg["activo"] = ($reg["activo"] ?
				" <a id=\"aActivar{$id}\" href=\"javascript:;\" onclick=\"xajax_Activar({$id})\" title=\"Desactivar\">".SWPHP::_Icon("green_button.png", 16, array("alt"=>"Desactivar"))."</a>"
				:
				" <a id=\"aActivar{$id}\" href=\"javascript:;\" onclick=\"xajax_Activar({$id})\" title=\"Activar\">".SWPHP::_Icon("red_button.png", 16, array("alt"=>"Activar"))."</a>")
			." <a href=\"".SWPHP_ADMIN_DIR.$swphp_mod_clave."/usuarios/?op=edit&amp;id={$id}\">".SWPHP::_Icon("edit.png", 16, array("alt"=>"Editar", "title"=>"Editar Id. {$id}"))."</a>"
			." <a id=\"aEliminar{$id}\" href=\"javascript:EliminarUsuario({$id})\" title=\"Eliminar\">".SWPHP::_Icon("remove.png", 16, array("alt"=>"Eliminar", "title"=>"Eliminar Id. {$id}"))."</a>";
	}
	$paginador->SetParam('applyToRegs', 'applyToReg');

	$admin_template = "{$swphp_module_templates_dir}admin/usuarios/usuarios.tpl";

	$smarty->assign('paginador', $paginador);

	$smarty->assign("kptl_config", $kptl_config);
    $smarty->assign('grupos', KPTL::GetGruposForHTMLSelect());
}
