<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-04-08
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/kapitaltruth/inc/transferencias.inc.php
 *
 */

$op = isset($_GET['op']) ? $_GET['op'] : '';

switch($op)
{
	case '':
	default:
		$moduletemplate = 'inc/transferencias.tpl';
		break;
	case 'hacer':
		if(isset($_POST['control']) && $_POST['control'] && $_POST['control'] == $_SESSION['control'])
		{
			$transferencia = new KPTL_Transferencia();

			$user_to = isset($_POST['user_id']) ? intval($_POST['user_id']) : 0;
			$puntos = isset($_POST['puntos']) ? intval($_POST['puntos']) : 0;
			$concepto = isset($_POST['concepto']) ? trim($_POST['concepto']) : '';
			$pass = isset($_POST['pass']) ? $_POST['pass'] : '';

			if($pass && SWPHP::_Encrypt($pass) == $kptl_user->GetValue('pass', false))
			{

				if($transferencia->Hacer($kptl_user_id, $user_to, $puntos, $concepto))
				{
					$kptl_user->Load(); //Actualizar usuario sesión

					SWPHP::_Msg(l('Transferencia realizada correctamente', 'kapitaltruth'), 'check');
				}
				else
				{
					SWPHP::_Msg(l('No se pudo realizar la transferencia', 'kapitaltruth'), 'error');
				}
			}
			else
			{
				SWPHP::_Msg(l('Contraseña incorrecta', 'kapitaltruth'), 'error');
			}
		}

		$moduletemplate = 'inc/transferencias/hacer.tpl';

		break;
	case 'emitidas':
		$fd = isset($_GET["fd"]) ? trim($_GET["fd"]) : false;
		$fh = isset($_GET["fh"]) ? trim($_GET["fh"]) : false;
		$ub = isset($_GET["ub"]) ? trim($_GET["ub"]) : false;
		$co = isset($_GET["co"]) ? trim($_GET["co"]) : false;

		$filtro_fd = $fd ? sprintf(" AND SUBSTRING(t.fechayhora, 1, LENGTH('%s')) >= '%s'", addcslashes($fd, "'"), addcslashes($fd, "'")) : "";
		$filtro_fh = $fh ? sprintf(" AND SUBSTRING(t.fechayhora, 1, LENGTH('%s')) <= '%s'", addcslashes($fh, "'"), addcslashes($fh, "'")) : "";
		$filtro_ub = $ub ? sprintf(" AND CONCAT(u.nick,' ',ku.nombre) LIKE _utf8 '%%%s%%' COLLATE utf8_general_ci", addcslashes($ub, "'")) : "";
		$filtro_co = $co ? sprintf(" AND t.concepto LIKE _utf8 '%%%s%%' COLLATE utf8_general_ci", addcslashes($co, "'")) : "";

		$paginador = SWPHP::_CrearPaginador('transferencias');
		$paginador->SetParam('etiqueta', l('transferencia emitida', 'kapitaltruth'));
		$paginador->Fill("SELECT t.fechayhora, CONCAT('(',u.nick,') ',ku.nombre) AS beneficiario, t.concepto, t.puntos"
			." FROM ".SWPHP_DBPREFIX."kptl_transferencias AS t"
    		." LEFT JOIN ".SWPHP_DBPREFIX."kptl_usuarios AS ku ON ku.id = t.user_to"
    		." LEFT JOIN ".SWPHP_DBPREFIX."users AS u ON u.id = ku.user_id"
    		." WHERE t.user_from = ".$kptl_user_id.$filtro_fd.$filtro_fh.$filtro_ub.$filtro_co
    		." ORDER BY t.fechayhora DESC, t.id DESC"
    		);
		$paginador->SetParam('campos', array(
			'fechayhora'=>array('label'=>l('Fecha', 'kapitaltruth'), 'style'=>'width:100px'),
			'beneficiario'=>array('label'=>l('Beneficiario', 'kapitaltruth'), 'style'=>'width:240px'),
			'concepto'=>array('label'=>l('Concepto', 'kapitaltruth')),
			'puntos'=>array('label'=>l('[KPTL_Puntos]', 'kapitaltruth'), 'class'=>'numeric', 'style'=>'width:80px'),
			));
		$paginador->SetParam('camposEstrictos', true);
		$paginador->SetParam('buscador', false);
		$paginador->SetParam('permitirOrdenacion', false);
		$paginador->SetParam('formato_tabla', array(
			'class'=>'listado middle',
			'width'=>'100%',
			'cellpadding'=>'0',
			'cellspacing'=>'0',
			'border'=>'0',
			));

		function applyToReg(&$reg, $key)
		{
			global $db;

			$reg['fechayhora'] = substr($reg['fechayhora'], 0, 10).'<span class="mini">'.substr($reg['fechayhora'], 10).'</span>';
			$reg['puntos'] .= ' '.l('[KPTL_puntos]', 'kapitaltruth');
		}
		$paginador->SetParam('applyToRegs', 'applyToReg');

		$smarty->assign(array(
			'fd'=>$fd,
			'fh'=>$fh,
			'ub'=>$ub,
			'co'=>$co,
			'paginador'=>$paginador
			));

		$moduletemplate = 'inc/transferencias/emitidas.tpl';

		break;
	case 'recibidas':
		$fd = isset($_GET["fd"]) ? trim($_GET["fd"]) : false;
		$fh = isset($_GET["fh"]) ? trim($_GET["fh"]) : false;
		$ue = isset($_GET["ue"]) ? trim($_GET["ue"]) : false;
		$co = isset($_GET["co"]) ? trim($_GET["co"]) : false;

		$filtro_fd = $fd ? sprintf(" AND SUBSTRING(t.fechayhora, 1, LENGTH('%s')) >= '%s'", addcslashes($fd, "'"), addcslashes($fd, "'")) : "";
		$filtro_fh = $fh ? sprintf(" AND SUBSTRING(t.fechayhora, 1, LENGTH('%s')) <= '%s'", addcslashes($fh, "'"), addcslashes($fh, "'")) : "";
		$filtro_ue = $ue ? sprintf(" AND CONCAT(u.nick,' ',ku.nombre) LIKE _utf8 '%%%s%%' COLLATE utf8_general_ci", addcslashes($ue, "'")) : "";
		$filtro_co = $co ? sprintf(" AND t.concepto LIKE _utf8 '%%%s%%' COLLATE utf8_general_ci", addcslashes($co, "'")) : "";

		$paginador = SWPHP::_CrearPaginador('transferencias');
		$paginador->SetParam('etiqueta', l('transferencia recibida', 'kapitaltruth'));
		$paginador->Fill("SELECT t.fechayhora, CONCAT('(',u.nick,') ',ku.nombre) AS emisor, t.concepto, t.puntos"
			." FROM ".SWPHP_DBPREFIX."kptl_transferencias AS t"
    		." LEFT JOIN ".SWPHP_DBPREFIX."kptl_usuarios AS ku ON ku.id = t.user_from"
    		." LEFT JOIN ".SWPHP_DBPREFIX."users AS u ON u.id = ku.user_id"
    		." WHERE t.user_to = ".$kptl_user_id.$filtro_fd.$filtro_fh.$filtro_ue.$filtro_co
    		." ORDER BY t.fechayhora DESC"
    		);
		$paginador->SetParam('campos', array(
			'fechayhora'=>array('label'=>l('Fecha', 'kapitaltruth'), 'style'=>'width:100px'),
			'emisor'=>array('label'=>l('Emisor', 'kapitaltruth'), 'style'=>'width:240px'),
			'concepto'=>array('label'=>l('Concepto', 'kapitaltruth')),
			'puntos'=>array('label'=>l('[KPTL_Puntos]', 'kapitaltruth'), 'class'=>'numeric', 'style'=>'width:80px'),
			));
		$paginador->SetParam('camposEstrictos', true);
		$paginador->SetParam('buscador', false);
		$paginador->SetParam('formato_tabla', array(
			'class'=>'listado middle',
			'width'=>'100%',
			'cellpadding'=>'0',
			'cellspacing'=>'0',
			'border'=>'0',
			));

		function applyToReg(&$reg, $key)
		{
			global $db;

			$reg['fechayhora'] = substr($reg['fechayhora'], 0, 10).'<span class="mini">'.substr($reg['fechayhora'], 10).'</span>';
			$reg['puntos'] .= ' '.l('[KPTL_puntos]', 'kapitaltruth');
		}
		$paginador->SetParam('applyToRegs', 'applyToReg');

		$smarty->assign(array(
			'fd'=>$fd,
			'fh'=>$fh,
			'ue'=>$ue,
			'co'=>$co,
			'paginador'=>$paginador
			));

		$moduletemplate = 'inc/transferencias/recibidas.tpl';

		break;
}

$kptl_template = SWPHP::_GetModuleTemplate($moduletemplate);
?>