<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2010-09-04
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/micuenta/admin/functions.inc.php
 *
 */

/**
 * Valida los datos de una cuenta de usuario
 *
 * @param array $data
 * @return bool
 */
function micuenta_validarDatos(&$data)
{
	include_once(SWPHP_COMMON_DIR."functions/validations.php");

	global $db;

	$ok = true;

	$requeridos = array(
		'apass'=>'Contraseña actual',
		);
	foreach($requeridos as $key=>$value)
	{
		if(!isset($data[$key]))
		{
			$ok = false;
			SWPHP::_Msg("Falta el dato requerido <b>{$value}</b>", 'error');
		}
	}

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case 'apass':
				if(!$db->Exists(SWPHP::_Encrypt($value), 'pass', SWPHP_DBPREFIX."users", "WHERE id = '{$_SESSION['user']['id']}'"))
				{
					$ok = false;
					SWPHP::_Msg('No has indicado tu contraseña actual correctamente', 'error');
				}
				break;
			case 'pass':
				if($value != '')
				{
					if(!validateString($value, SWPHP_PASSWORD_MINLENGTH, SWPHP_PASSWORD_MAXLENGTH, SWPHP_PASSWORD_VALIDCHARS))
					{
						$ok = false;
						SWPHP::_Msg('Nueva contraseña no válida', 'error');
					}
					elseif($value != $data['cpass'])
					{
						$ok = false;
						SWPHP::_Msg('No has confirmado la nueva contraseña correctamente', 'error');
					}
				}
				break;

			//TODO: ¿idioma_id?
		}
	}

	return $ok;
}
/**
 * Prepara los datos para actualizar una cuenta de usuario
 *
 * @param array $data
 * @return array
 */
function micuenta_prepararDatos($data)
{
	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case 'camposuser':
				//TODO: Quitar los que no tenga permiso de escritura
				break;
			case 'idioma_id':
				$data[$key] = intval($value);
				break;
			case 'pass':
				if($value)
				{
					break;
				}
				//sigue
			default:
				unset($data[$key]); //Descartamos cualquier otro dato
				break;
		}
	}

	return $data;
}
