<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-02-03
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/paginas/admin/functions.inc.php
 *
 */

/**
 * Elimina una página y todas las páginas que cuelgan de ella
 *
 * @param int $id
 */
function paginas_eliminarPagina($id)
{
	global $db;

	$rows = $db->GetRows("SELECT id FROM ".SWPHP_DBPREFIX."paginas WHERE padre_id = '{$id}'");
	foreach($rows AS $row)
	{
		paginas_eliminarPagina($row["id"]);
	}

	if($db->Execute("DELETE FROM ".SWPHP_DBPREFIX."paginas WHERE id = '{$id}'"))
	{
		$db->Execute("DELETE FROM ".SWPHP_DBPREFIX."paginas_idiomas WHERE pagina_id = '{$id}'");
		$db->Execute("DELETE FROM ".SWPHP_DBPREFIX."menuprincipal WHERE pagina_id = '{$id}'");
		$db->Execute("DELETE FROM ".SWPHP_DBPREFIX."menuprincipal WHERE padre_id > 0 AND padre_id NOT IN(SELECT id FROM ".SWPHP_DBPREFIX."menuprincipal)");

		return true;
	}

	return false;
}
/**
 * Obtiene las opciones correspondientes a las páginas para un elemento select de formulario
 *
 * @param int $current_id
 * @param int $nivel
 * @param int $padre_id
 * @return array
 */
function paginas_getSelectPaginas($current_id=0, $nivel=0, $padre_id=0)
{
	return SWPHP::_Rows2AssocTree(
		SWPHP_DBPREFIX.'paginas AS p LEFT JOIN '.SWPHP_DBPREFIX.'paginas_idiomas AS pi ON p.id = pi.pagina_id AND pi.idioma_id = '.SWPHP_IDIOMA_POR_DEFECTO,
		'pi.titulo',
		'p.id',
		'p.padre_id',
		'p.esteril = \'0\' ORDER BY p.padre_id, p.peso',
		array('0', '[Es una página raíz]'),
		$current_id,
		$nivel,
		$padre_id
		);
}
/**
 * Valida los datos de un registro de página
 *
 * @param array $data
 * @return bool
 */
function paginas_validarDatos($data)
{
	global $swphp_idiomas;

	$ok = true;

	if(!isset($data['padre_id']) || $data['padre_id'] == '')
	{
		SWPHP::_Msg("Falta el dato: Página padre", "error");
		$ok = false;
	}

	$requeridos = array(
		'titulo'=>'Título',
		'textoenlace'=>'Texto enlace',
		);

	foreach($requeridos as $key=>$nombre)
	{
		if(!isset($data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key]) || $data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key] == '')
		{
			SWPHP::_Msg("Falta el dato: {$nombre} ({$swphp_idiomas[SWPHP_IDIOMA_POR_DEFECTO]['nombre']})", "error");
			$ok = false;
		}
	}

	return $ok;
}
/**
 * Prepara los datos para insertar o actualizar una página en la base de datos
 *
 * @param array $data
 * @param int $id
 * @return array
 */
function paginas_prepararDatos($data, $id=0)
{
	global $db;

	$data['enmenucontextual'] = isset($data['enmenucontextual']);
	$data['considebox'] = isset($data['considebox']);
	$data['conmenucontextual'] = isset($data['conmenucontextual']);
	$data['mapaweb'] = isset($data['mapaweb']);

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case "padre_id":
			case "estilo_id":
				$data[$key] = intval($value);
				break;
			case "icono":
				$data[$key] = trim($value);
				break;
			case "enmenucontextual":
			case "considebox":
			case "conmenucontextual":
			case "mapaweb":
				//Nada porque ya lo hemos puesto bien al inicio de la función,
				//pero hay que ponerlos en el switch para que no los descarte
				break;
			default:
				//Cualquier otro dato lo descarto
				unset($data[$key]);
				break;
		}
	}

	$ahora = date('Y-m-d H:i:s');
	if($id == 0)
	{
		$data['fechayhoraregistro'] = $ahora;
		$data['user_idregistro'] = $_SESSION['user']['id'];
	}
	$data['fechayhoraultima'] = $ahora;
	$data['user_idultima'] = $_SESSION['user']['id'];

	return $data;
}
/**
 * Prepara los datos para insertar o actualizar datos de una página en idioma
 *
 * @param array $idiomas
 * @param int $idioma_id
 * @param int $padre_id
 * @param int $id
 * @return array
 */
function paginas_prepararDatosIdioma($idiomas, $idioma_id, $padre_id, $id)
{
	global $db;

	$friendly = empty($idiomas[$idioma_id]['friendly']) && !empty($idiomas[SWPHP_IDIOMA_POR_DEFECTO]['friendly']) ? '' : (isset($idiomas[$idioma_id]['friendly']) ? $idiomas[$idioma_id]['friendly'] : '');

	$data = SWPHP::_PrepararDatosIdioma($idiomas, $idioma_id, array('titulo','descripcion','keywords','textoenlace','title','friendly'));

	$data['friendly'] = string2friendly($friendly ? $friendly : $data['titulo']);

	$c = 1;
	$friendly = ($id == SWPHP::_GetConfigValue("portada", "paginas", false) ? "" : $data['friendly']); //string2friendly($data['titulo']));
	//Evitamos que salga una url como el directorio de administración
	if($padre_id == 0 && "{$friendly}/" == SWPHP_ADMIN_DIR)
	{
		$friendly = "{$friendly}-{$c}";
		$c++;
	}
	$data['friendly'] = $friendly;
	//Evitamos urls repetidas
	while($db->ExistsQuery("SELECT pi.friendly FROM ".SWPHP_DBPREFIX."paginas AS p JOIN ".SWPHP_DBPREFIX."paginas_idiomas AS pi ON p.id = pi.pagina_id WHERE p.padre_id = '{$padre_id}' AND p.id != '{$id}' AND pi.idioma_id = '{$idioma_id}' AND pi.friendly = '{$data['friendly']}'"))
	{
		$data['friendly'] = "{$friendly}-{$c}";
		$c++;
	}

	$data['pagina_id'] = $id;
	$data['idioma_id'] = $idioma_id;

	return $data;
}
/**
 * Prepara los datos para registrar/actualizar el contenido de una página en la base de datos, para un idioma
 *
 * @param array $idiomas
 * @param int $idioma_id
 * @param bool $preview
 * @param int $id
 * @return array
 */
function paginas_prepararDatosHTMLIdioma($idiomas, $idioma_id, $preview, $id)
{
	global $db, $swphp_config, $swphp_idiomas;

	if(!empty($swphp_config['idioma']['autotranslate']) && !empty($swphp_config['idioma']['googletranslateapikey']))
	{
		include_once(SWPHP_COMMON_DIR.'classes/MyCurl.class.php');
		include_once(SWPHP_COMMON_DIR.'classes/GoogleTranslate.class.php');

		$gtranslate = new GoogleTranslate($swphp_config['idioma']['googletranslateapikey']);
	}
	else
	{
		$gtranslate = false;
	}

	$data = $idiomas[$idioma_id];

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case "preview":
				$data[$key] = trim($value);
				if($data[$key] == '' && $idioma_id != SWPHP_IDIOMA_POR_DEFECTO && !empty($idiomas[SWPHP_IDIOMA_POR_DEFECTO][$key]))
				{
					$data[$key] = $gtranslate ? $gtranslate->T(trim($idiomas[SWPHP_IDIOMA_POR_DEFECTO][$key]), SWPHP_IDIOMA_POR_DEFECTO_CODIGOISO, $swphp_idiomas[$idioma_id]['codigoiso']) : trim($idiomas[SWPHP_IDIOMA_POR_DEFECTO][$key]);
				}
				break;
			case "contenido":
				if($preview)
				{
					unset($data[$key]); //Lo descartamos
				}
				else
				{
					$data[$key] = addcslashes(base64_decode(trim($value)), "'");
					if($data[$key] == '' && $idioma_id != SWPHP_IDIOMA_POR_DEFECTO && !empty($idiomas[SWPHP_IDIOMA_POR_DEFECTO][$key]))
					{
						$data[$key] = $gtranslate ? $gtranslate->T(addcslashes(base64_decode(trim($idiomas[SWPHP_IDIOMA_POR_DEFECTO][$key])), "'"), SWPHP_IDIOMA_POR_DEFECTO_CODIGOISO, $swphp_idiomas[$idioma_id]['codigoiso']) : addcslashes(base64_decode(trim($idiomas[SWPHP_IDIOMA_POR_DEFECTO][$key])), "'");
					}
				}
				break;
			default:
				//Descartamos cualquier otro dato
				unset($data[$key]);
				break;
		}
	}

	/*
	//Si es un módulo marco la página como estéril, si no no
	$data['esteril'] = strpos($data['contenido'], '[swphp:modulo]') !== false ? '1' : '0';
	*/

	$data['pagina_id'] = $id;
	$data['idioma_id'] = $idioma_id;

	return $data;
}
