<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-08-10
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/paginas/install.php
 *
 */

/**
 * Realiza las actuaciones particulares de la instalación de este módulo:
 *
 * @param array $info
 * @return bool
 */
function paginas_instalar($info)
{
	global $swphp_idiomas;

	$ok = true;

	SWPHP::_ExecuteQuery("SET NAMES 'utf8'", "", "");

	$ahora = date('Y-m-d H:i:s');

	$queries = array(
		"CREATE TABLE IF NOT EXISTS `".SWPHP_DBPREFIX."paginas` (
		  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  `padre_id` int(10) unsigned NOT NULL DEFAULT '0',
		  `fechayhoraregistro` datetime NOT NULL,
		  `fechayhoraultima` datetime NOT NULL,
		  `user_idregistro` int(10) unsigned NOT NULL,
		  `user_idultima` int(10) unsigned NOT NULL,
		  `peso` smallint(5) unsigned NOT NULL DEFAULT '100',
		  `considebox` tinyint(1) unsigned NOT NULL DEFAULT '1',
		  `enmenucontextual` tinyint(1) unsigned NOT NULL DEFAULT '1',
		  `conmenucontextual` tinyint(1) unsigned NOT NULL DEFAULT '0',
		  `activo` tinyint(1) unsigned NOT NULL DEFAULT '1',
		  `icono` varchar(60) NOT NULL DEFAULT '',
		  `editable` tinyint(1) unsigned NOT NULL DEFAULT '1',
		  `esteril` tinyint(1) unsigned NOT NULL DEFAULT '0',
		  `estilo_id` smallint(5) unsigned NOT NULL DEFAULT '0',
		  PRIMARY KEY (`id`),
		  KEY `padre_id` (`padre_id`)
		) DEFAULT CHARSET=utf8",
		"CREATE TABLE IF NOT EXISTS `".SWPHP_DBPREFIX."paginas_idiomas` (
		  `pagina_id` int(10) unsigned NOT NULL,
		  `idioma_id` smallint(5) unsigned NOT NULL,
		  `titulo` varchar(120) NOT NULL DEFAULT '',
		  `descripcion` varchar(255) NOT NULL DEFAULT '',
		  `keywords` varchar(255) NOT NULL DEFAULT '',
		  `textoenlace` varchar(60) NOT NULL DEFAULT '',
		  `title` varchar(120) NOT NULL DEFAULT '',
		  `contenido` text NOT NULL,
		  `preview` text NOT NULL,
		  `friendly` varchar(60) NOT NULL DEFAULT '',
		  PRIMARY KEY (`pagina_id`,`idioma_id`)
		) DEFAULT CHARSET=utf8",
		sprintf("INSERT INTO `".SWPHP_DBPREFIX."paginas`(id, fechayhoraregistro, fechayhoraultima, user_idregistro, user_idultima) VALUES(1, '%s', '%s', 0, 0)", $ahora, $ahora),
		);

	foreach($swphp_idiomas as $idioma_id=>$idioma)
	{
		$queries[] = sprintf("INSERT INTO `".SWPHP_DBPREFIX."paginas_idiomas`(pagina_id, idioma_id, titulo, descripcion, keywords, textoenlace, title, contenido) VALUES(1, %u, 'Portada', 'Página web realizada con Simple web PHP Edición Administrada', 'pagina, web, realizada, simple, php, edicion, administrada', 'Portada', 'Portada', 'Bienvenido a mi página web')", $idioma_id);
	}

	foreach($queries as $query)
	{
		$ok &= SWPHP::_ExecuteQuery($query, "", "No se pudo ejecutar la sentencia:<br /> {$query}");
	}

	$ok &= SWPHP::_CreateConfigValue('portada', '1', 'paginas', 'tag=select;options=SWPHP::_Rows2AssocTree(SWPHP_DBPREFIX.\'paginas AS p JOIN \'.SWPHP_DBPREFIX.\'paginas_idiomas AS pi ON pi.pagina_id IN(p.id)\', \'pi.titulo\', \'p.id\', \'p.padre_id\',  \'1 ORDER BY p.padre_id, p.peso\', array(\'0\', \'\'))', 'Página de portada');

	return $ok;
}
/**
 * Realiza las actuaciones particulares de la desinstalación de este módulo
 *
 * @param array $info
 * @return bool
 */
function paginas_desinstalar($info)
{
	//Es un módulo core

	return false;

	/*
	global $db;

	$ok = true;

	$queries = array(
		"DROP TABLE IF EXISTS ".SWPHP_DBPREFIX."paginas",
		"DROP TABLE IF EXISTS ".SWPHP_DBPREFIX."paginas_idiomas",
		);
	foreach($queries as $query)
	{
		$ok &= SWPHP::_ExecuteQuery($query, "", "No se pudo ejecutar la sentencia:<br /> {$query}");
	}

	$ok &= SWPHP::_DeleteAllConfigValues('paginas');

	return $ok;
	*/
}