<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2010-08-31
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/usuarios/admin/index.php
 *
 */

require_once(SWPHP_COMMON_DIR.'classes/DB_Reg.class.php');
require_once(SWPHP_COMMON_DIR.'classes/SWPHP_Reg.class.php');
require_once(SWPHP_COMMON_DIR.'classes/SWPHP_User.class.php');

$id = isset($_GET["id"]) ? intval($_GET["id"]) : 0;
$op = isset($_GET['op']) ? $_GET['op'] : '';

$user = new SWPHP_User($id);

$mostrarprincipal = true;

switch($op)
{
	case "edit":
	case "new":
		$smarty->assign("registro", $user->GetData());
		$smarty->assign('perfiles', SWPHP::_GetPerfiles(1, $_SESSION['user']['perfil_id']));
		$smarty->assign('camposuser', SWPHP::_GetCamposUser());
		$admin_template = "{$swphp_module_templates_dir}admin/usuario.tpl";
		$mostrarprincipal = false;
		break;
	case "upd":
	case "reg":
		if(usuarios_validarDatos($_POST, $id))
		{
			$data = usuarios_prepararDatos($_POST);

			if(sizeof($data) > 0)
			{
				if($user->SetData($data) && $user->Save())
				{
					SWPHP::_Msg("Datos guardados correctamente", 'check');
				}
				else
				{
					SWPHP::_Msg("No se ha podido guardar los datos", 'error');
				}
			}
		}
		break;
}

unset($user);

if($mostrarprincipal)
{
	$paginador = SWPHP::_CrearPaginador('usuarios');
	$paginador->SetParam('etiqueta', 'usuario');
	$paginador->Fill("SELECT u.id, u.nick, u.email, pi.nombre AS perfil, u.contadorlogin, SUBSTRING(u.ultimologin,1,16) AS ultimologin, u.activo FROM ".SWPHP_DBPREFIX."users AS u LEFT JOIN ".SWPHP_DBPREFIX."perfiles_idiomas AS pi ON pi.perfil_id = u.perfil_id AND pi.idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."' WHERE u.perfil_id <= '{$_SESSION['user']['perfil_id']}' ORDER BY u.nick ASC");

	$paginador->SetParam('campos', array(
		'id'=>array("label"=>"Id.", "class"=>"numeric"),
		'nick'=>array("label"=>"Nick"),
		'email'=>array("label"=>"Email"),
		'perfil'=>array("label"=>"Perfil"),
		'contadorlogin'=>array("label"=>"Accesos", "class"=>"numeric"),
		'ultimologin'=>array("label"=>"Último acceso", "class"=>"center"),
		'activo'=>array("label"=>"", "orderby"=>false)
		));

	$paginador->SetParam('buscador', array(
		'u.nick'=>'Nick',
		'u.email'=>'Email',
		'p.nombre'=>'Perfil',
		'SUBSTRING(u.ultimologin,1,16)'=>'Último login',
		'u.id'=>'Id.',
		));

	function applyToReg(&$reg, $key)
	{
		global $swphp_mod_clave;

		$id = $reg['id'];

		$reg["activo"] = "<a href=\"".SWPHP_ADMIN_DIR.$swphp_mod_clave."/?op=edit&amp;id={$id}\">".SWPHP::_Icon("edit.png", 16, array("alt"=>"Editar", "title"=>"Editar Id. {$id}"))."</a>"
			.($reg["activo"] ?
				" <a id=\"aActivar{$id}\" href=\"javascript:;\" onclick=\"xajax_Activar({$id})\" title=\"Desactivar\">".SWPHP::_Icon("green_button.png", 16, array("alt"=>"Desactivar"))."</a>"
				:
				" <a id=\"aActivar{$id}\" href=\"javascript:;\" onclick=\"xajax_Activar({$id})\" title=\"Activar\">".SWPHP::_Icon("red_button.png", 16, array("alt"=>"Activar"))."</a>")
			." <a id=\"aEliminar{$id}\" href=\"javascript:EliminarUsuario({$id})\" title=\"Eliminar\">".SWPHP::_Icon("remove.png", 16, array("alt"=>"Eliminar"))."</a>";
	}
	$paginador->SetParam('applyToRegs', 'applyToReg');

	$admin_template = "{$swphp_module_templates_dir}admin/usuarios.tpl";

	$smarty->assign('paginador', $paginador);
}
?>